/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
)

// checks if the SyncContactRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SyncContactRequest{}

// SyncContactRequest struct for SyncContactRequest
type SyncContactRequest struct {
	ContactId string `json:"contact_id"`
	OrganizationId string `json:"organization_id"`
	Strategy string `json:"strategy"`
}

// NewSyncContactRequest instantiates a new SyncContactRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSyncContactRequest(contactId string, organizationId string, strategy string) *SyncContactRequest {
	this := SyncContactRequest{}
	this.ContactId = contactId
	this.OrganizationId = organizationId
	this.Strategy = strategy
	return &this
}

// NewSyncContactRequestWithDefaults instantiates a new SyncContactRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSyncContactRequestWithDefaults() *SyncContactRequest {
	this := SyncContactRequest{}
	return &this
}

// GetContactId returns the ContactId field value
func (o *SyncContactRequest) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *SyncContactRequest) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *SyncContactRequest) SetContactId(v string) {
	o.ContactId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *SyncContactRequest) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *SyncContactRequest) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *SyncContactRequest) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetStrategy returns the Strategy field value
func (o *SyncContactRequest) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *SyncContactRequest) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *SyncContactRequest) SetStrategy(v string) {
	o.Strategy = v
}

func (o SyncContactRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SyncContactRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["contact_id"] = o.ContactId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["strategy"] = o.Strategy
	return toSerialize, nil
}

type NullableSyncContactRequest struct {
	value *SyncContactRequest
	isSet bool
}

func (v NullableSyncContactRequest) Get() *SyncContactRequest {
	return v.value
}

func (v *NullableSyncContactRequest) Set(val *SyncContactRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSyncContactRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSyncContactRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSyncContactRequest(val *SyncContactRequest) *NullableSyncContactRequest {
	return &NullableSyncContactRequest{value: val, isSet: true}
}

func (v NullableSyncContactRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSyncContactRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


